varval(File):-
	g_assign(lst_sol,[]),
	
	\+find_all_sol,
	
	open(File,write,ReStream),
	print_header(ReStream),
	print_sol(ReStream),
	close(ReStream)
	.

find_all_sol:-
	toto(L),
%	flatten(A,L),
%	append(Lvar,Lpos,L),
%	array_values(A,L),
	add_sol(L,1),
	fail.
	

add_sol([],_).
add_sol([Val|L],Var):-
	g_read(lst_sol,Lst_sol),
	(member(Var-Val-Som,Lst_sol)->
		Som2 is Som+1,
		subtract(Lst_sol,[Var-Val-Som],Lst_sol2),
		g_assign(lst_sol,[Var-Val-Som2|Lst_sol2])
		;
		g_assign(lst_sol,[Var-Val-1|Lst_sol])
	),
	Var2 is Var+1,
	add_sol(L,Var2).
	
print_sol(ReStream):-
	g_read(lst_sol,Lst_sol),
	length(Lst_sol,Lg),
	write(Lst_sol),nl,
	(for(I,1,Lg),
	nth(I,Lst_sol,Elt),
	Elt=Var-Val-Som,
	format(ReStream,'~d\t~d\t~d\n',[Var,Val,Som]),
	fail;true)
	.
	

% Esieve
fields([field("Var",  "Integer",  "-",    "-"),
       field("Val",   "Integer", "-",    "-"),
       field("NbSol",  "Integer", "-",    "-")]).


print_header(Esieve):-
	fields(Fields),
	( member(field(Name,_,_,_), Fields),
	  format(Esieve, '~s\t', [Name]),
	  fail
        ; format(Esieve, '\n', []) ),
	( member(field(_,Type,_,_), Fields),
	  format(Esieve, '~s\t', [Type]),
          fail
        ; format(Esieve, '\n', []) ),
	( member(field(_,_,Enum,_), Fields),
	  format(Esieve, '~s\t', [Enum]),
          fail
        ; format(Esieve, '\n', []) ),
	( member(field(_,_,_,Date), Fields),
	  format(Esieve, '~s\t', [Date]),
          fail
        ; format(Esieve, '\n', []) ),
	  format(Esieve, '\n', []).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
varval2(File):-
	g_assign(lst_sol,[]),
	
	\+find_all_sol2,
	
	open(File,write,ReStream),
	print_header2(ReStream),
	print_sol2(ReStream),
	close(ReStream)
	.

find_all_sol2:-
	golf3_sbds(4,2,4,R),
	add_sol2(R,1),
	fail.

add_sol2([],_).
add_sol2([P1|RP],I1):-
	add_sol3(P1,I1,1),
	I2 is I1+1,
	add_sol2(RP,I2).
	
add_sol3([],_,_).
add_sol3([Val|L],Var1,Var2):-
	g_read(lst_sol,Lst_sol),
	(member(Var1-Var2-Val-Som,Lst_sol)->
		Som2 is Som+1,
		subtract(Lst_sol,[Var1-Var2-Val-Som],Lst_sol2),
		g_assign(lst_sol,[Var1-Var2-Val-Som2|Lst_sol2])
		;
		g_assign(lst_sol,[Var1-Var2-Val-1|Lst_sol])
	),
	Varp1 is Var2+1,
	add_sol3(L,Var1,Varp1).
	
print_sol2(ReStream):-
	g_read(lst_sol,Lst_sol),
	length(Lst_sol,Lg),
	write(Lst_sol),nl,
	(for(I,1,Lg),
	nth(I,Lst_sol,Elt),
	Elt=Var1-Var2-Val-Som,
	format(ReStream,'~d\t~d\t~d\t~d\n',[Var1,Var2,Val,Som]),
	fail;true)
	.
	

% Esieve
fields2([field("Var1",  "Integer",  "-",    "-"),
	field("Var2",  "Integer",  "-",    "-"),
	field("Val",   "Integer", "-",    "-"),
	field("NbSol",  "Integer", "-",    "-")]).


print_header2(Esieve):-
	fields2(Fields),
	( member(field(Name,_,_,_), Fields),
	  format(Esieve, '~s\t', [Name]),
	  fail
        ; format(Esieve, '\n', []) ),
	( member(field(_,Type,_,_), Fields),
	  format(Esieve, '~s\t', [Type]),
          fail
        ; format(Esieve, '\n', []) ),
	( member(field(_,_,Enum,_), Fields),
	  format(Esieve, '~s\t', [Enum]),
          fail
        ; format(Esieve, '\n', []) ),
	( member(field(_,_,_,Date), Fields),
	  format(Esieve, '~s\t', [Date]),
          fail
        ; format(Esieve, '\n', []) ),
	  format(Esieve, '\n', []).



